diff --git a/samples/virtcca-server/rats-server.c b/samples/virtcca-server/rats-server.c
new file mode 100644
index 0000000..e48723c
--- /dev/null
+++ b/samples/virtcca-server/rats-server.c
@@ -0,0 +1,350 @@
+/* Copyright (c) 2021 Intel Corporation
+ * Copyright (c) 2020-2021 Alibaba Cloud
+ *
+ * SPDX-License-Identifier: Apache-2.0
+ */
+
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+#include <strings.h>
+#include <getopt.h>
+#include <errno.h>
+#include <unistd.h>
+#include <sys/socket.h>
+#include <arpa/inet.h>
+#include <netinet/in.h>
+#include <netinet/tcp.h>
+#include <rats-tls/api.h>
+#include <rats-tls/log.h>
+#include <rats-tls/claim.h>
+
+#define DEFAULT_PORT 1234
+#define DEFAULT_IP   "0.0.0.0" /* Listern to connections from any ip */
+#define TOKEN "ATTESTATION_PASS"
+#define IMA_MEASUREMENTS_PATH "/sys/kernel/security/ima/binary_runtime_measurements"
+#define IMA_READ_BLCOK_SIZE 1024
+
+rats_tls_err_t read_ima_measurements(uint8_t **value, size_t *size)
+{
+	FILE *file;
+	uint8_t buffer[IMA_READ_BLCOK_SIZE];
+	size_t byte_read;
+
+	file = fopen(IMA_MEASUREMENTS_PATH, "rb");
+	if (file == NULL) {
+		RTLS_ERR("Error opening file: %s\n", strerror(errno));
+		return RATS_TLS_ERR_INVALID;
+	}
+	RTLS_INFO("file opened: %s\n", IMA_MEASUREMENTS_PATH);
+
+	while ((byte_read = fread(buffer, 1, IMA_READ_BLCOK_SIZE, file)) > 0) {
+		uint8_t *content = realloc(*value, *size + byte_read);
+		if (content == NULL) {
+			free(*value);
+			RTLS_ERR("memory reallocation failed");
+			return RATS_TLS_ERR_NO_MEM;
+		}
+
+		*value = content;
+		memcpy(*value + *size, buffer, byte_read);
+		*size += byte_read;
+	}
+
+	fclose(file);
+	return RATS_TLS_ERR_NONE;
+}
+
+int rats_tls_server_startup(rats_tls_log_level_t log_level, char *attester_type,
+			    char *verifier_type, char *tls_type, char *crypto_type, bool mutual,
+				bool ima, bool provide_endorsements, char *ip, int port)
+{
+	rats_tls_conf_t conf;
+	rats_tls_err_t ret;
+	uint8_t *ima_meas = NULL;
+	size_t ima_size = 0;
+    char pass_token[] = TOKEN;
+    int pass_token_len = sizeof(pass_token);
+	memset(&conf, 0, sizeof(conf));
+	conf.log_level = log_level;
+	strcpy(conf.attester_type, attester_type);
+	strcpy(conf.verifier_type, verifier_type);
+	strcpy(conf.tls_type, tls_type);
+	strcpy(conf.crypto_type, crypto_type);
+
+	conf.cert_algo = RATS_TLS_CERT_ALGO_DEFAULT;
+	conf.flags |= RATS_TLS_CONF_FLAGS_SERVER;
+	if (mutual)
+		conf.flags |= RATS_TLS_CONF_FLAGS_MUTUAL;
+	if (ima)
+		ret = read_ima_measurements(&ima_meas, &ima_size);
+		if (ret == 0 && ima_size != 0) {
+			RTLS_INFO("read %zu bytes from binary_runtime_measurements\n", ima_size);
+			claim_t custom_claims[1] = {
+				{ .name = "ima", .value = ima_meas, .value_size = ima_size }
+			};
+			conf.custom_claims = (claim_t *)custom_claims;
+			conf.custom_claims_length = 1;
+			RTLS_INFO("Step\n");
+		} else {
+			RTLS_ERR("failed to read binary_runtime_measurements\n");
+		}
+	if (provide_endorsements)
+		conf.flags |= RATS_TLS_CONF_FLAGS_PROVIDE_ENDORSEMENTS;
+
+	int sockfd = socket(AF_INET, SOCK_STREAM, 0);
+	if (sockfd < 0) {
+		RTLS_ERR("Failed to call socket()");
+		return -1;
+	}
+
+	int reuse = 1;
+	if (setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, (const void *)&reuse, sizeof(int)) < 0) {
+		RTLS_ERR("Failed to call setsockopt()");
+		return -1;
+	}
+
+	/* Set keepalive options */
+	int flag = 1;
+	int tcp_keepalive_time = 30;
+	int tcp_keepalive_intvl = 10;
+	int tcp_keepalive_probes = 5;
+	if (setsockopt(sockfd, SOL_SOCKET, SO_KEEPALIVE, &flag, sizeof(flag)) < 0) {
+		RTLS_ERR("Failed to call setsockopt()");
+		return -1;
+	}
+	if (setsockopt(sockfd, SOL_TCP, TCP_KEEPIDLE, &tcp_keepalive_time,
+		       sizeof(tcp_keepalive_time)) < 0) {
+		RTLS_ERR("Failed to call setsockopt()");
+		return -1;
+	}
+	if (setsockopt(sockfd, SOL_TCP, TCP_KEEPINTVL, &tcp_keepalive_intvl,
+		       sizeof(tcp_keepalive_intvl)) < 0) {
+		RTLS_ERR("Failed to call setsockopt()");
+		return -1;
+	}
+	if (setsockopt(sockfd, SOL_TCP, TCP_KEEPCNT, &tcp_keepalive_probes,
+		       sizeof(tcp_keepalive_probes)) < 0) {
+		RTLS_ERR("Failed to call setsockopt()");
+		return -1;
+	}
+
+	struct sockaddr_in s_addr;
+	memset(&s_addr, 0, sizeof(s_addr));
+	s_addr.sin_family = AF_INET;
+	s_addr.sin_addr.s_addr = inet_addr(ip);
+	s_addr.sin_port = htons(port);
+
+	/* Bind the server socket */
+	if (bind(sockfd, (struct sockaddr *)&s_addr, sizeof(s_addr)) == -1) {
+		RTLS_ERR("Failed to call bind()");
+		return -1;
+	}
+
+	/* Listen for a new connection, allow 5 pending connections */
+	if (listen(sockfd, 5) == -1) {
+		RTLS_ERR("Failed to call listen()");
+		return -1;
+	}
+
+	rats_tls_handle handle;
+
+	ret = rats_tls_init(&conf, &handle);
+	if (ret != RATS_TLS_ERR_NONE) {
+		RTLS_ERR("Failed to initialize rats tls %#x\n", ret);
+		goto err;
+	}
+
+	ret = rats_tls_set_verification_callback(&handle, NULL);
+	if (ret != RATS_TLS_ERR_NONE) {
+		RTLS_ERR("Failed to set verification callback %#x\n", ret);
+		goto err;
+	}
+
+	while (1) {
+		RTLS_INFO("Waiting for a connection ...\n");
+
+		/* Accept client connections */
+		struct sockaddr_in c_addr;
+		socklen_t size = sizeof(c_addr);
+
+		int connd = accept(sockfd, (struct sockaddr *)&c_addr, &size);
+		if (connd < 0) {
+			RTLS_ERR("Failed to call accept()");
+			continue;
+		}
+
+		ret = rats_tls_negotiate(handle, connd);
+		if (ret != RATS_TLS_ERR_NONE) {
+			RTLS_ERR("Failed to negotiate %#x\n", ret);
+			continue;
+		}
+
+		RTLS_DEBUG("Client connected successfully\n");
+
+		char buf[1024];
+		size_t len = sizeof(buf);
+		ret = rats_tls_receive(handle, buf, &len);
+		if (ret != RATS_TLS_ERR_NONE) {
+			RTLS_ERR("Failed to receive %#x\n", ret);
+			continue;
+		}
+
+		if (len >= sizeof(buf))
+			len = sizeof(buf) - 1;
+		buf[len] = '\0';
+
+		RTLS_INFO("Received from Client: %s\n", buf);
+
+        if (strncmp(buf, pass_token, pass_token_len) == 0) {
+            strcpy(buf, "Attestation Passed, Swtiching Root.....");
+            /* Reply back to the client */
+			len = sizeof(buf);
+            ret = rats_tls_transmit(handle, buf, &len);
+            if (ret != RATS_TLS_ERR_NONE) {
+                RTLS_ERR("Failed to transmit %#x\n", ret);
+            }
+            break;
+        } else {
+            strcpy(buf, "Attestation Failed, Continue.....");
+            /* Reply back to the client */
+			len = sizeof(buf);
+            ret = rats_tls_transmit(handle, buf, &len);
+            if (ret != RATS_TLS_ERR_NONE) {
+                RTLS_ERR("Failed to transmit %#x\n", ret);
+            }
+			continue;
+        }
+
+		close(connd);
+	}
+
+	if (ima_meas != NULL) {
+		free(ima_meas);
+	}
+
+	shutdown(sockfd, SHUT_RDWR);
+	close(sockfd);
+	ret = rats_tls_cleanup(handle);
+	if (ret != RATS_TLS_ERR_NONE) {
+		RTLS_ERR("Failed to cleanup %#x\n", ret);
+		return ret;
+	} else {
+		return 0x67;
+	}
+
+err:
+	/* Ignore the error code of cleanup in order to return the prepositional error */
+	shutdown(sockfd, SHUT_RDWR);
+    close(sockfd);
+	rats_tls_cleanup(handle);
+	return -1;
+
+}
+
+int main(int argc, char **argv)
+{
+	char *const short_options = "a:v:t:c:mIel:i:p:h";
+	// clang-format off
+        struct option long_options[] = {
+                { "attester", required_argument, NULL, 'a' },
+                { "verifier", required_argument, NULL, 'v' },
+                { "tls", required_argument, NULL, 't' },
+                { "crypto", required_argument, NULL, 'c' },
+                { "mutual", no_argument, NULL, 'm' },
+				{ "ima", no_argument, NULL, 'I'},
+                { "endorsements", no_argument, NULL, 'e' },
+                { "log-level", required_argument, NULL, 'l' },
+                { "ip", required_argument, NULL, 'i' },
+                { "port", required_argument, NULL, 'p' },
+                { "help", no_argument, NULL, 'h' },
+                { 0, 0, 0, 0 }
+        };
+	// clang-format on
+
+	char *attester_type = "";
+	char *verifier_type = "";
+	char *tls_type = "";
+	char *crypto_type = "";
+	bool mutual = false;
+	bool ima = false;
+	bool provide_endorsements = false;
+	rats_tls_log_level_t log_level = RATS_TLS_LOG_LEVEL_INFO;
+	char *ip = DEFAULT_IP;
+	int port = DEFAULT_PORT;
+	int opt;
+
+	do {
+		opt = getopt_long(argc, argv, short_options, long_options, NULL);
+		switch (opt) {
+		case 'a':
+			attester_type = optarg;
+			break;
+		case 'v':
+			verifier_type = optarg;
+			break;
+		case 't':
+			tls_type = optarg;
+			break;
+		case 'c':
+			crypto_type = optarg;
+			break;
+		case 'm':
+			mutual = true;
+			break;
+		case 'I':
+			ima = true;
+			break;
+		case 'e':
+			provide_endorsements = true;
+			break;
+		case 'l':
+			if (!strcasecmp(optarg, "debug"))
+				log_level = RATS_TLS_LOG_LEVEL_DEBUG;
+			else if (!strcasecmp(optarg, "info"))
+				log_level = RATS_TLS_LOG_LEVEL_INFO;
+			else if (!strcasecmp(optarg, "warn"))
+				log_level = RATS_TLS_LOG_LEVEL_WARN;
+			else if (!strcasecmp(optarg, "error"))
+				log_level = RATS_TLS_LOG_LEVEL_ERROR;
+			else if (!strcasecmp(optarg, "fatal"))
+				log_level = RATS_TLS_LOG_LEVEL_FATAL;
+			else if (!strcasecmp(optarg, "off"))
+				log_level = RATS_TLS_LOG_LEVEL_NONE;
+			break;
+		case 'i':
+			ip = optarg;
+			break;
+		case 'p':
+			port = atoi(optarg);
+			break;
+		case -1:
+			break;
+		case 'h':
+			puts("    Usage:\n\n"
+			     "        rats-tls-server <options> [arguments]\n\n"
+			     "    Options:\n\n"
+			     "        --attester/-a value   set the type of quote attester\n"
+			     "        --verifier/-v value   set the type of quote verifier\n"
+			     "        --tls/-t value        set the type of tls wrapper\n"
+			     "        --crypto/-c value     set the type of crypto wrapper\n"
+			     "        --mutual/-m           set to enable mutual attestation\n"
+				 "        --ima/-I              set to enable ima\n"
+			     "        --endorsements/-e     set to let attester provide endorsements\n"
+			     "        --log-level/-l        set the log level\n"
+			     "        --ip/-i               set the listening ip address\n"
+			     "        --port/-p             set the listening tcp port\n"
+			     "        --help/-h             show the usage\n");
+			exit(1);
+			/* Avoid compiling warning */
+			break;
+		default:
+			exit(1);
+		}
+	} while (opt != -1);
+
+	global_log_level = log_level;
+
+	return rats_tls_server_startup(log_level, attester_type, verifier_type, tls_type,
+				       crypto_type, mutual, ima, provide_endorsements, ip, port);
+}
diff --git a/src/CMakeLists.txt b/src/CMakeLists.txt
index de69760..98e75b7 100644
--- a/src/CMakeLists.txt
+++ b/src/CMakeLists.txt
@@ -2,9 +2,12 @@
 set(INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include
                  ${CMAKE_CURRENT_SOURCE_DIR}/include/rats-tls
                  ${CMAKE_CURRENT_SOURCE_DIR}/include/internal
-                 /opt/intel/sgxsdk/include
-                 /usr/include
+                 /usr/include/
                  )
+if(NOT VIRTCCA)
+    list(APPEND INCLUDE_DIRS /opt/intel/sgxsdk/include)
+endif()
+
 if(SGX)
     list(APPEND INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include/edl
                              ${CMAKE_BINARY_DIR}/src/sgx/trust
@@ -121,4 +124,4 @@ set(RTLS_INCLUDE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/include/rats-tls/api.h
                        )
 install(DIRECTORY DESTINATION ${RATS_TLS_INSTALL_INCLUDE_PATH})
 install(FILES ${RTLS_INCLUDE_FILES}
-DESTINATION ${RATS_TLS_INSTALL_INCLUDE_PATH})
+        DESTINATION ${RATS_TLS_INSTALL_INCLUDE_PATH})
diff --git a/src/api/rats_tls_init.c b/src/api/rats_tls_init.c
index 39e64cd..6ddacf6 100644
--- a/src/api/rats_tls_init.c
+++ b/src/api/rats_tls_init.c
@@ -121,14 +121,6 @@ rats_tls_err_t rats_tls_init(const rats_tls_conf_t *conf, rats_tls_handle *handl
 	if (err != RATS_TLS_ERR_NONE)
 		goto err_ctx;
 
-	/* Check whether requiring to generate TLS certificate */
-	if ((ctx->config.flags & RATS_TLS_CONF_FLAGS_SERVER) ||
-	    (ctx->config.flags & RATS_TLS_CONF_FLAGS_MUTUAL)) {
-		err = rtls_core_generate_certificate(ctx);
-		if (err != RATS_TLS_ERR_NONE)
-			goto err_ctx;
-	}
-
 	*handle = ctx;
 
 	RTLS_DEBUG("the handle %p returned\n", ctx);
diff --git a/src/attesters/CMakeLists.txt b/src/attesters/CMakeLists.txt
index 103c8d0..7bb2ca6 100644
--- a/src/attesters/CMakeLists.txt
+++ b/src/attesters/CMakeLists.txt
@@ -19,3 +19,7 @@ endif()
 if(SGX)
     add_subdirectory(sgx-la)
 endif()
+
+if(VIRTCCA)
+    add_subdirectory(virtcca)
+endif()
\ No newline at end of file
diff --git a/src/attesters/api/enclave_attester_register.c b/src/attesters/api/enclave_attester_register.c
index a59849c..a5a8fd1 100644
--- a/src/attesters/api/enclave_attester_register.c
+++ b/src/attesters/api/enclave_attester_register.c
@@ -12,7 +12,7 @@
 #include "internal/cpu.h"
 
 enclave_attester_err_t enclave_attester_register(const enclave_attester_opts_t *opts)
-{
+{	
 	if (!opts)
 		return -ENCLAVE_ATTESTER_ERR_INVALID;
 
@@ -26,9 +26,7 @@ enclave_attester_err_t enclave_attester_register(const enclave_attester_opts_t *
 			// clang-format on
 			return -ENCLAVE_ATTESTER_ERR_CPU_UNSUPPORTED;
 		}
-	}
-
-	if (opts->flags & ENCLAVE_ATTESTER_OPTS_FLAGS_SNP_GUEST) {
+	} else if (opts->flags & ENCLAVE_ATTESTER_OPTS_FLAGS_SNP_GUEST) {
 		if (!is_snpguest_supported()) {
 			// clang-format off
 			RTLS_DEBUG("failed to register the attester '%s' due to lack of SNP Guest capability\n",
@@ -36,9 +34,7 @@ enclave_attester_err_t enclave_attester_register(const enclave_attester_opts_t *
 			// clang-format on
 			return -ENCLAVE_ATTESTER_ERR_CPU_UNSUPPORTED;
 		}
-	}
-
-	if (opts->flags & ENCLAVE_ATTESTER_OPTS_FLAGS_SEV_GUEST) {
+	} else if (opts->flags & ENCLAVE_ATTESTER_OPTS_FLAGS_SEV_GUEST) {
 		if (!is_sevguest_supported()) {
 			// clang-format off
 			RTLS_DEBUG("failed to register the attester '%s' due to lack of SEV(-ES) Guest capability\n",
@@ -46,9 +42,7 @@ enclave_attester_err_t enclave_attester_register(const enclave_attester_opts_t *
 			// clang-format on
 			return -ENCLAVE_ATTESTER_ERR_CPU_UNSUPPORTED;
 		}
-	}
-
-	if (opts->flags & ENCLAVE_ATTESTER_OPTS_FLAGS_CSV_GUEST) {
+	} else if (opts->flags & ENCLAVE_ATTESTER_OPTS_FLAGS_CSV_GUEST) {
 		if (!is_csvguest_supported()) {
 			// clang-format off
 			RTLS_DEBUG("failed to register the attester '%s' due to lack of CSV Guest capability\n",
@@ -56,6 +50,21 @@ enclave_attester_err_t enclave_attester_register(const enclave_attester_opts_t *
 			// clang-format on
 			return -ENCLAVE_ATTESTER_ERR_CPU_UNSUPPORTED;
 		}
+	} else if (opts->flags & ENCLAVE_ATTESTER_OPTS_FLAGS_VIRTCCA_GUEST) {
+		if (!is_virtccaguest_supported()) {
+			// clang-format off
+			RTLS_DEBUG("failed to register the attester '%s' due to lack of VirtCCA Guest capability\n",
+				   opts->type);
+			// clang-format on
+			return -ENCLAVE_ATTESTER_ERR_CPU_UNSUPPORTED;
+		}
+	} else if (opts->flags & ENCLAVE_ATTESTER_OPTS_FLAGS_VIRTCCA_FAKE) {
+		RTLS_DEBUG("ignore checking capability for attester '%s'\n", opts->type);
+	} else if (opts->flags == ENCLAVE_ATTESTER_FLAGS_DEFAULT) {
+		RTLS_DEBUG("ignore checking capability for nullattester\n");	
+	} else {
+		RTLS_DEBUG("unknown attester opts->flag '%lx'\n", opts->flags);
+		return -ENCLAVE_ATTESTER_ERR_UNKNOWN;
 	}
 
 	enclave_attester_opts_t *new_opts = (enclave_attester_opts_t *)malloc(sizeof(*new_opts));
diff --git a/src/attesters/csv/collect_evidence.c b/src/attesters/csv/collect_evidence.c
index 6707cf9..d7079c8 100644
--- a/src/attesters/csv/collect_evidence.c
+++ b/src/attesters/csv/collect_evidence.c
@@ -239,8 +239,7 @@ static int collect_attestation_evidence(uint8_t *hash, uint32_t hash_len,
 	// clang-fomat off
 	/* Prepare user defined data (challenge and mnonce) */
 	memcpy(user_data->data, hash,
-	       hash_len <= CSV_ATTESTATION_USER_DATA_SIZE ? hash_len :
-							    CSV_ATTESTATION_USER_DATA_SIZE);
+	       hash_len <= CSV_ATTESTATION_USER_DATA_SIZE ? hash_len : CSV_ATTESTATION_USER_DATA_SIZE);
 	// clang-format on
 
 	gen_random_bytes(user_data->mnonce, CSV_ATTESTATION_MNONCE_SIZE);
diff --git a/src/attesters/csv/pre_init.c b/src/attesters/csv/pre_init.c
index 4a4e1ea..9447192 100644
--- a/src/attesters/csv/pre_init.c
+++ b/src/attesters/csv/pre_init.c
@@ -11,10 +11,13 @@ enclave_attester_err_t csv_attester_pre_init(void)
 {
 	RTLS_DEBUG("called\n");
 
-	if (!system("wget -V >/dev/null 2>&1"))
-		return ENCLAVE_ATTESTER_ERR_NONE;
+	enclave_attester_err_t err = ENCLAVE_ATTESTER_ERR_NONE;
 
-	RTLS_ERR("Please install wget for csv attester\n");
+	char *cmdline_str = "which wget 1> /dev/null 2> /dev/null";
+	if (system(cmdline_str) != 0) {
+		RTLS_ERR("please install wget for csv attest\n");
+		err = -ENCLAVE_ATTESTER_ERR_NO_TOOL;
+	}
 
-	return -ENCLAVE_ATTESTER_ERR_NO_TOOL;
+	return err;
 }
diff --git a/src/attesters/internal/rtls_enclave_attester_load_all.c b/src/attesters/internal/rtls_enclave_attester_load_all.c
index 6e997ee..7aaa04e 100644
--- a/src/attesters/internal/rtls_enclave_attester_load_all.c
+++ b/src/attesters/internal/rtls_enclave_attester_load_all.c
@@ -41,23 +41,20 @@ rats_tls_err_t rtls_enclave_attester_load_all(void)
 	unsigned int total_loaded = 0;
 	rtls_dirent *ptr;
 	while ((rtls_readdir(dir, &ptr)) != 1) {
-		const char *d_name = ptr->d_name;
-
-		if (!strcmp(d_name, ".") || !strcmp(d_name, ".."))
+		if (!strcmp(ptr->d_name, ".") || !strcmp(ptr->d_name, ".."))
 			continue;
-
-		if (strncmp(d_name + strlen(d_name) - strlen(PATTERN_SUFFIX), PATTERN_SUFFIX,
-			    strlen(PATTERN_SUFFIX)))
+		if (strncmp(ptr->d_name + strlen(ptr->d_name) - strlen(PATTERN_SUFFIX),
+			    PATTERN_SUFFIX, strlen(PATTERN_SUFFIX)))
 			continue;
 
 #ifdef OCCLUM
 		/* Occlum can't identify the d_type of the file, always return DT_UNKNOWN */
-		if (strncmp(d_name + strlen(d_name) - strlen(PATTERN_SUFFIX), PATTERN_SUFFIX,
-			    strlen(PATTERN_SUFFIX)) == 0) {
+		if (strncmp(ptr->d_name + strlen(ptr->d_name) - strlen(PATTERN_SUFFIX),
+			    PATTERN_SUFFIX, strlen(PATTERN_SUFFIX)) == 0) {
 #else
 		if (ptr->d_type == DT_REG || ptr->d_type == DT_LNK) {
 #endif
-			if (rtls_enclave_attester_load_single(d_name) == RATS_TLS_ERR_NONE)
+			if (rtls_enclave_attester_load_single(ptr->d_name) == RATS_TLS_ERR_NONE)
 				++total_loaded;
 		}
 	}
diff --git a/src/attesters/tdx-ecdsa/pre_init.c b/src/attesters/tdx-ecdsa/pre_init.c
index c59114a..bd5d93d 100644
--- a/src/attesters/tdx-ecdsa/pre_init.c
+++ b/src/attesters/tdx-ecdsa/pre_init.c
@@ -4,6 +4,7 @@
  * SPDX-License-Identifier: Apache-2.0
  */
 
+#include <internal/cpu.h>
 #include <rats-tls/attester.h>
 #include <rats-tls/log.h>
 
diff --git a/src/attesters/virtcca/CMakeLists.txt b/src/attesters/virtcca/CMakeLists.txt
new file mode 100644
index 0000000..4fc4818
--- /dev/null
+++ b/src/attesters/virtcca/CMakeLists.txt
@@ -0,0 +1,30 @@
+# Project name
+project(attester_virtcca)
+
+# Set include directory
+list(APPEND INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR})
+
+include_directories(${INCLUDE_DIRS})
+
+# Set dependency library directory
+set(LIBRARY_DIRS ${CMAKE_BINARY_DIR}/src
+                 ${RATS_TLS_INSTALL_LIB_PATH}
+                 )
+link_directories(${LIBRARY_DIRS})
+
+# Set source file
+set(SOURCES cleanup.c
+            collect_evidence.c
+            init.c
+            main.c
+            pre_init.c
+            )
+
+# Generate library
+add_library(${PROJECT_NAME} SHARED ${SOURCES})
+target_link_libraries(${PROJECT_NAME} ${RATS_TLS_LDFLAGS} ${RTLS_LIB} vccaattestation)
+set_target_properties(${PROJECT_NAME} PROPERTIES VERSION ${VERSION} SOVERSION ${VERSION_MAJOR})
+
+# Install library
+install(TARGETS ${PROJECT_NAME}
+        DESTINATION ${RATS_TLS_INSTALL_LIBA_PATH})
diff --git a/src/attesters/virtcca/cleanup.c b/src/attesters/virtcca/cleanup.c
new file mode 100644
index 0000000..fe3ec58
--- /dev/null
+++ b/src/attesters/virtcca/cleanup.c
@@ -0,0 +1,14 @@
+#include <rats-tls/log.h>
+#include <rats-tls/attester.h>
+#include <attestation.h>
+
+enclave_attester_err_t virtcca_attester_cleanup(__attribute__((unused)) enclave_attester_ctx_t *ctx)
+{
+	RTLS_DEBUG("called\n");
+	
+	tsi_ctx *virtcca_ctx = (tsi_ctx *)ctx->attester_private;
+
+	tsi_free_ctx(virtcca_ctx);
+
+	return ENCLAVE_ATTESTER_ERR_NONE;
+}
diff --git a/src/attesters/virtcca/collect_evidence.c b/src/attesters/virtcca/collect_evidence.c
new file mode 100644
index 0000000..2f15551
--- /dev/null
+++ b/src/attesters/virtcca/collect_evidence.c
@@ -0,0 +1,67 @@
+#include <rats-tls/log.h>
+#include <rats-tls/attester.h>
+#include <string.h>
+#include <attestation.h>
+#include <sys/ioctl.h>
+#include <fcntl.h>
+#include <unistd.h>
+
+#define CHALLENGE_SIZE 64
+
+enclave_attester_err_t virtcca_collect_evidence(enclave_attester_ctx_t *ctx,
+						     attestation_evidence_t *evidence,
+						     rats_tls_cert_algo_t algo, uint8_t *hash,
+						     uint32_t hash_len)
+{
+	RTLS_DEBUG("ctx %p, evidence %p, algo %d, hash %p\n", ctx, evidence, algo, hash);
+	tsi_ctx *virtcca_ctx = tsi_new_ctx();
+	if (!virtcca_ctx) {
+        RTLS_ERR("failed to open device: /dev/tsi");
+		return -ENCLAVE_ATTESTER_ERR_NO_TOOL;
+    }
+	unsigned char challenge[CHALLENGE_SIZE] = {0};
+	size_t challenge_len = CHALLENGE_SIZE;
+	size_t token_len;
+	size_t device_cert_len;
+	unsigned char *token;
+	unsigned char *device_cert;
+	virtcca_attestation_evidence_t *virtcca_token = &evidence->virtcca;
+    int ret;
+
+	/* Prepare user defined data, i.e., challenge */
+	if (hash_len > CHALLENGE_SIZE) {
+		RTLS_ERR("hash length: %d, challenge_size: %d\n", hash_len, CHALLENGE_SIZE);
+	}
+	challenge_len = hash_len <= CHALLENGE_SIZE ? hash_len : CHALLENGE_SIZE;
+	memcpy(challenge, hash, challenge_len);
+
+	token = virtcca_token->report + sizeof(token_len);
+	token_len = REPORT_MAX_LENGTH - sizeof(token_len);
+	ret = get_attestation_token(virtcca_ctx, challenge, challenge_len, token, &token_len);
+	if (ret != 0) {
+		RTLS_ERR("failed to get attestation token (%d)\n", ret);
+		tsi_free_ctx(virtcca_ctx);
+		return -ENCLAVE_ATTESTER_ERR_INVALID;
+	}
+	memcpy(virtcca_token->report, &token_len, sizeof(token_len));
+
+	device_cert = virtcca_token->report + sizeof(token_len) + token_len + sizeof(device_cert_len);
+	device_cert_len = REPORT_MAX_LENGTH - sizeof(token_len) - token_len - sizeof(device_cert_len);
+	ret = get_dev_cert(virtcca_ctx, device_cert, &device_cert_len);
+	if (ret != 0) {
+		RTLS_ERR("failed to get device cert (%d)\n", ret);
+		tsi_free_ctx(virtcca_ctx);
+		return -ENCLAVE_ATTESTER_ERR_INVALID;
+	}
+	memcpy(virtcca_token->report + sizeof(token_len) + token_len, &device_cert_len, sizeof(device_cert_len));
+
+	virtcca_token->report_len = token_len + device_cert_len + sizeof(token_len) + sizeof(device_cert_len);
+
+	tsi_free_ctx(virtcca_ctx);
+
+	snprintf(evidence->type, sizeof(evidence->type), "virtcca");
+
+	RTLS_DEBUG("ctx %p, evidence %p, report_len %d\n", ctx, evidence, evidence->sev.report_len);
+
+	return ENCLAVE_ATTESTER_ERR_NONE;
+}
diff --git a/src/attesters/virtcca/init.c b/src/attesters/virtcca/init.c
new file mode 100644
index 0000000..0b72628
--- /dev/null
+++ b/src/attesters/virtcca/init.c
@@ -0,0 +1,29 @@
+#include <rats-tls/log.h>
+#include <rats-tls/attester.h>
+#include <attestation.h>
+#include <sys/ioctl.h>
+#include <fcntl.h>
+
+enclave_attester_err_t virtcca_attester_init(enclave_attester_ctx_t *ctx, rats_tls_cert_algo_t algo)
+{
+	RTLS_DEBUG("ctx %p, algo %d\n", ctx, algo);
+	int ret;
+	int major, minor;
+	tsi_ctx *virtcca_ctx = tsi_new_ctx();
+	if (!virtcca_ctx) {
+        RTLS_ERR("failed to open device: /dev/tsi");
+		return -ENCLAVE_ATTESTER_ERR_NO_TOOL;
+    }
+
+	ret = get_version(virtcca_ctx, &major, &minor);
+    if (ret != 0) {
+        RTLS_ERR("failed to get TSI version (%d)", ret);
+        return -ENCLAVE_ATTESTER_ERR_INVALID;
+    }
+
+    RTLS_DEBUG("TSI version %d.%d advertised\n", major, minor);
+
+	ctx->attester_private = virtcca_ctx;
+
+	return ENCLAVE_ATTESTER_ERR_NONE;
+}
diff --git a/src/attesters/virtcca/main.c b/src/attesters/virtcca/main.c
new file mode 100644
index 0000000..89426a0
--- /dev/null
+++ b/src/attesters/virtcca/main.c
@@ -0,0 +1,33 @@
+#include <stdio.h>
+#include <rats-tls/attester.h>
+#include <rats-tls/log.h>
+
+extern enclave_attester_err_t enclave_attester_register(enclave_attester_opts_t *);
+extern enclave_attester_err_t virtcca_attester_pre_init(void);
+extern enclave_attester_err_t virtcca_attester_init(enclave_attester_ctx_t *,
+												 	rats_tls_cert_algo_t algo);
+extern enclave_attester_err_t virtcca_collect_evidence(enclave_attester_ctx_t *,
+													   attestation_evidence_t *,
+													   rats_tls_cert_algo_t algo, uint8_t *,
+													   uint32_t hash_len);
+extern enclave_attester_err_t virtcca_attester_cleanup(enclave_attester_ctx_t *);
+
+static enclave_attester_opts_t virtcca_attester_opts = {
+	.api_version = ENCLAVE_ATTESTER_API_VERSION_DEFAULT,
+	.flags = ENCLAVE_ATTESTER_OPTS_FLAGS_VIRTCCA_GUEST,
+	.name = "virtcca",
+	.priority = 15,
+	.pre_init = virtcca_attester_pre_init,
+	.init = virtcca_attester_init,
+	.collect_evidence = virtcca_collect_evidence,
+	.cleanup = virtcca_attester_cleanup,
+};
+
+void __attribute__((constructor)) libattester_virtcca_init(void)
+{
+	RTLS_DEBUG("called\n");
+
+	enclave_attester_err_t err = enclave_attester_register(&virtcca_attester_opts);
+	if (err != ENCLAVE_ATTESTER_ERR_NONE)
+		RTLS_DEBUG("failed to register the enclave attester 'virtcca' %#x\n", err);
+}
diff --git a/src/attesters/virtcca/pre_init.c b/src/attesters/virtcca/pre_init.c
new file mode 100644
index 0000000..0fd3c55
--- /dev/null
+++ b/src/attesters/virtcca/pre_init.c
@@ -0,0 +1,9 @@
+#include <rats-tls/log.h>
+#include <rats-tls/attester.h>
+
+enclave_attester_err_t virtcca_attester_pre_init(void)
+{
+	RTLS_DEBUG("called\n");
+
+	return ENCLAVE_ATTESTER_ERR_NONE;
+}
diff --git a/src/core/cpu.c b/src/core/cpu.c
index ad48924..f1d53cf 100644
--- a/src/core/cpu.c
+++ b/src/core/cpu.c
@@ -20,7 +20,7 @@
 #include "rtls_t.h"
 #endif
 // clang-format on
-
+#ifndef __aarch64__ /* AARCH64 */
 #ifndef SGX
 // clang-format off
 static inline void cpuid(int *eax, int *ebx, int *ecx, int *edx)
@@ -51,10 +51,12 @@ static bool is_sgx_device(const char *dev)
 {
 	struct stat st;
 
-	if (stat(dev, &st))
-		return false;
+	if (!stat(dev, &st)) {
+		if ((st.st_mode & S_IFCHR) && (major(st.st_rdev) == SGX_DEVICE_MAJOR_NUM))
+			return true;
+	}
 
-	return (st.st_mode & S_IFCHR) && (major(st.st_rdev) == SGX_DEVICE_MAJOR_NUM);
+	return false;
 }
 
 static bool is_legacy_oot_kernel_driver(void)
@@ -194,7 +196,6 @@ bool is_tdguest_supported(void)
 static uint64_t read_msr(uint32_t reg)
 {
 	int fd = open("/dev/cpu/0/msr", O_RDONLY);
-
 	if (fd < 0) {
 		RTLS_ERR("failed to open msr\n");
 		return 0;
@@ -203,7 +204,7 @@ static uint64_t read_msr(uint32_t reg)
 	uint64_t data;
 	if (pread(fd, &data, sizeof(data), reg) != sizeof(data)) {
 		close(fd);
-		RTLS_ERR("failed to read msr %#x\n", reg);
+		RTLS_DEBUG("failed to read msr %#x\n", reg);
 		return 0;
 	}
 
@@ -213,39 +214,26 @@ static uint64_t read_msr(uint32_t reg)
 }
 #endif
 
-static bool is_amd_cpu(void)
-{
-	int cpu_info[4] = { 0, 0, 0, 0 };
-
-	__cpuidex(cpu_info, 0, 0);
-
-	/* The twelve 8-bit ASCII character codes that form the
-	 * string "AuthenticAMD".
-	 */
-	return (cpu_info[1] == 0x68747541 && cpu_info[2] == 0x444d4163 &&
-		cpu_info[3] == 0x69746e65);
-}
+#define X86_CPUID_VENDOR_HygonGenuine_ebx 0x6f677948
+#define X86_CPUID_VENDOR_HygonGenuine_ecx 0x656e6975
+#define X86_CPUID_VENDOR_HygonGenuine_edx 0x6e65476e
 
-static bool is_hygon_cpu(void)
+/* check CPU vendor of the guest */
+bool is_hygon_cpu(void)
 {
 	int cpu_info[4] = { 0, 0, 0, 0 };
 
 	__cpuidex(cpu_info, 0, 0);
 
-	/* The twelve 8-bit ASCII character codes that form the
-         * string "HygonGenuine".
-         */
-	return (cpu_info[1] == 0x6f677948 && cpu_info[2] == 0x656e6975 &&
-		cpu_info[3] == 0x6e65476e);
+	return (cpu_info[1] == X86_CPUID_VENDOR_HygonGenuine_ebx &&
+		cpu_info[2] == X86_CPUID_VENDOR_HygonGenuine_ecx &&
+		cpu_info[3] == X86_CPUID_VENDOR_HygonGenuine_edx);
 }
 
 /* check whether running in AMD SEV-SNP guest */
 bool is_snpguest_supported(void)
 {
 #ifndef SGX
-	if (!is_amd_cpu())
-		return false;
-
 	return !!(read_msr(SEV_STATUS_MSR) & (1 << SEV_SNP_FLAG));
 #else
 	return false;
@@ -256,11 +244,13 @@ bool is_snpguest_supported(void)
 bool is_sevguest_supported(void)
 {
 #ifndef SGX
-	if (!is_amd_cpu())
-		return false;
+	if (!is_hygon_cpu()) {
+		uint64_t data = read_msr(SEV_STATUS_MSR);
 
-	uint64_t data = read_msr(SEV_STATUS_MSR);
-	return !!data || !!(data & (1 << SEV_ES_FLAG));
+		return !!data || !!(data & (1 << SEV_ES_FLAG));
+	} else {
+		return false;
+	}
 #else
 	return false;
 #endif
@@ -270,12 +260,75 @@ bool is_sevguest_supported(void)
 bool is_csvguest_supported(void)
 {
 #ifndef SGX
-	if (!is_hygon_cpu())
-		return false;
+	if (is_hygon_cpu()) {
+		uint64_t data = read_msr(SEV_STATUS_MSR);
 
-	uint64_t data = read_msr(SEV_STATUS_MSR);
-	return !!(data & ((1 << SEV_FLAG) | (1 << SEV_ES_FLAG)));
+		return !!(data & ((1 << SEV_FLAG) | (1 << SEV_ES_FLAG)));
+	} else {
+		return false;
+	}
 #else
 	return false;
 #endif
 }
+
+/* check whether running in ARM VirtCCA guest */
+bool is_virtccaguest_supported(void)
+{	
+	return false;
+}
+
+#else /* AARCH64 */
+
+bool is_csvguest_supported(void)
+{
+	return false;
+}
+
+bool is_sevguest_supported(void)
+{
+	return false;
+}
+
+bool is_snpguest_supported(void)
+{
+	return false;
+}
+
+static bool is_sgx_device(const char *dev)
+{
+	return false;
+}
+
+static bool is_legacy_oot_kernel_driver(void)
+{
+	return false;
+}
+
+static bool is_in_tree_kernel_driver(void)
+{
+	return false;
+}
+
+static bool is_dcap_1_9_oot_kernel_driver(void)
+{
+	return false;
+}
+
+bool is_tdguest_supported(void)
+{
+	return false;
+}
+
+/* check whether running in ARM VirtCCA guest */
+bool is_virtccaguest_supported(void)
+{	
+	struct stat st;
+	if (stat("/dev/tsi", &st) == 0) {
+		if (S_ISCHR(st.st_mode))
+			return true;
+	}
+	return false;
+}
+
+#endif /* AARCH64 */
\ No newline at end of file
